<?php

defined('_JEXEC') or die('Restricted access');
require_once dirname(__FILE__).'/paslibs/paslibs.php';
class plgSystemRSFPPas extends JPlugin
{
	protected $componentId = 649;
	protected $componentValue = 'pas';

	public function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$this->newComponents = array(649);
	}

	/*
	 * display pas menu item in page formsazi
	 */
	public function rsfp_bk_onAfterShowComponents()
	{
		JFactory::getLanguage()->load('plg_system_rsfppas');

		$formId = JFactory::getApplication()->input->getInt('formId');

		$link = "displayTemplate('" . $this->componentId . "')";
		if ($components = RSFormProHelper::componentExists($formId, $this->componentId))
			$link = "displayTemplate('" . $this->componentId . "', '" . $components[0] . "')";
		?>
		<li><a href="javascript: void(0);" onclick="<?php echo $link; ?>;return false;"
			   id="rsfpc<?php echo $this->componentId; ?>"><span class="rsficon rsficon-pas"></span><span
					class="inner-text">درگاه پرداخت الکترونیک سپهر</span></a></li>
		<?php
	}

	/*
	 * get what type of payment is ex. MABNA or pas
	 */
	public function rsfp_getPayment(&$items, $formId)
	{
		if ($components = RSFormProHelper::componentExists($formId, $this->componentId)) {
			$data = RSFormProHelper::getComponentProperties($components[0]);

			$item = new stdClass();
			$item->value = $this->componentValue;
			$item->text = $data['LABEL'];

			// add to array
			$items[] = $item;
		}
	}

	/*
	 * do payment:
	 * get config and redirect to pas
	 */
	public function rsfp_doPayment($payValue, $formId, $SubmissionId, $price, $products, $code)
	{

		$app = JFactory::getApplication();



		if ($payValue != $this->componentValue)
			throw new Exception(JText::_('پلاکین مورد استفاده مبنا کارت نمی باشد'));
		if ($price <= 0)
			throw new Exception(JText::_('مبلغ نباید منفی یا صفر باشد'));

		$terminal_id = RSFormProHelper::getConfig('pas.terminal');
		if (empty($terminal_id))
			throw new Exception(JText::_('ترمینال پذیرنده را در قسمت تنظیمات وارد کنید'));

		$Amount = $this->PasAmount($price);
		$Description = JText::_('محصولات فروخته شامل ') . implode(', ', $products);

		if (empty($formId))
			$formId = $app->input->getInt('formId');

		$CallbackURL = JURI::root() . 'index.php?option=com_rsform&formId=' . $formId . '&task=plugin&amount=' . $Amount . '&code=' . $code;
		$setPayment = pasClass::setPas($Amount,'',$terminal_id,$CallbackURL);
		echo $setPayment;
		exit;

		
	}

	/*
	 * detect currency for amount
	 */
	private function PasAmount($price)
	{
		$currency = RSFormProHelper::getConfig('payment.currency');
		switch ($currency)
		{
			case 'ریال':
			case 'IRR':
			case 'RIAL':
			case 'Rial':
			case 'rial':
				$price = (int)$price;
				break;
			case 'تومان':
			case 'IRT':
			case 'TOMAN':
			case 'Toman':
			case 'toman':
			default:
				$price = (int)($price * 10);
				break;
		}
		return $price;
	}


	/*
	 * this will set display of pas payment into form
	 */
	public function rsfp_bk_onAfterCreateComponentPreview($args = array())
	{
		if ($args['ComponentTypeName'] == 'pas') {
			$args['out'] = '<td>&nbsp;</td>';
			$args['out'] .= '<td><span style="font-size:24px;margin-right:5px" class="rsficon rsficon-pas"></span> ' . $args['data']['LABEL'] . '</td>';
		}
	}

	/*
	 * this will be done when configuration page displayed
	 * and call function 'PasConfigurationScreen'
	 */
	public function rsfp_bk_onAfterShowConfigurationTabs($tabs)
	{
		JFactory::getLanguage()->load('plg_system_rsfppas');

		$tabs->addTitle('تنظیمات درگاه پرداخت الکترونیک سپهر', 'form-pas');
		$tabs->addContent($this->PasConfigurationScreen());
	}

	/*
	 * check to see what to do when back to site from pas
	 */
	public function rsfp_f_onSwitchTasks()
	{
		
			$app = JFactory::getApplication();
			$input = $app->input;

			$Amount = $input->getInt('amount');
			$Authority = $input->getString('Authority');
			$MerchantID = RSFormProHelper::getConfig('pas.terminal');

			$root = JURI::root();
			$return = RSFormProHelper::getConfig('pas.return');
            $return = empty($return) ? $root : $return;
			$htmlStart = "<!DOCTYPE html><html><head><meta charset='utf-8' ></head><body>";
			$htmlEnd = "</body></html>";
			

			if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
			{
				$db = JFactory::getDbo();
				$query = $db->getQuery(true);
				 $query->select(array('COUNT(*)'))->from($db->quoteName('#__rsform_submission_values'))
				 ->where($db->quoteName('FieldValue') . ' LIKE '. $db->quote('%'.$_POST['digitalreceipt'].'%'));
				$db->setQuery($query);
				$results = $db->loadResult();
				if($results == 0)
				{
					 $payResult = pasClass::getPas($_POST,$MerchantID); 
				}else
				{
					$payResult[0] = 0;
					$payResult[1] = 'رسید قبلا استفاده شده است';
				}
			}
			else
			{
				$payResult[0] = 0;
				$payResult[1] = $_POST['respmsg'];
			}
			
			if($payResult[0])
			{
				$RefID = $payResult[2];
				$db = JFactory::getDBO();
				$code = $input->getCmd('code');
				$formId = $input->getInt('formId');
				$db->setQuery("SELECT SubmissionId FROM #__rsform_submissions s WHERE s.FormId='" . $formId . "' AND MD5(CONCAT(s.SubmissionId,s.DateSubmitted)) = '" . $db->escape($code) . "'");
				if ($SubmissionId = $db->loadResult()) 
				{
					echo $formId;
					$db->setQuery("UPDATE #__rsform_submission_values sv SET sv.FieldValue=1 WHERE sv.FieldName='_STATUS' AND sv.FormId='".$formId."' AND sv.SubmissionId = '".$SubmissionId."'");
                        $db->execute();
						$db->setQuery("INSERT INTO `#__rsform_submission_values` (`SubmissionValueId`, `FormId`, `SubmissionId`, `FieldName`, `FieldValue`) VALUES (NULL, '".$formId."', '".$SubmissionId."', 'pasrefid', '".$RefID."');");
                        $db->execute();
                        $mainframe = JFactory::getApplication();
                        $mainframe->triggerEvent('rsfp_afterConfirmPayment', array($SubmissionId));
				}
				

				 JFactory::getApplication()->enqueueMessage("با تشکر پرداخت شما با موفقیت انجام شد. شماره تراکنش پرداخت : $RefID",'success'); 
			}else
			{

				JFactory::getApplication()->enqueueMessage("تراکنش شما ناموفق بوده و لغو شده است شرح خطا: $payResult[1]",'error'); 
			}

			

		
	}

	/*
	 * create pas configuration page
	 */
	private function PasConfigurationScreen()
	{
		ob_start();

		?>
		<div id="page-pas" class="com-rsform-css-fix">
			<table class="admintable">
				

				<tr>
					<td width="200" style="width: 200px;" align="right" class="key"><label
							for="terminal">ترمینال</label></td>
					<td><input id="terminal" type="text" name="rsformConfig[pas.terminal]"
							   value="<?php echo RSFormProHelper::htmlEscape(RSFormProHelper::getConfig('pas.terminal')); ?>"
							   size="100" maxlength="64"></td>
				</tr>


                <tr>
                    <td width="200" style="width: 200px;" align="right" class="key"><label
                            for="return">آدرس صفحه برگشت</label></td>
                    <td><input id="return" type="text" name="rsformConfig[pas.return]"
                               value="<?php echo RSFormProHelper::htmlEscape(RSFormProHelper::getConfig('pas.return')); ?>"
                               size="200" maxlength="500"></td>
                </tr>
            </table>
		</div>
		<?php

		$contents = ob_get_contents();
		ob_end_clean();
		return $contents;
	}
}
